import { createOAuthApp as publicCreateOAuthApp, getOAuthApp as publicGetOAuthApp, updateOAuthApp as publicUpdateOAuthApp, queryOAuthApps as publicQueryOAuthApps } from './headless-v1-o-auth-app-o-auth-apps.public.js';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
import { onOAuthAppCreated as publicOnOAuthAppCreated } from './headless-v1-o-auth-app-o-auth-apps.public.js';
import { onOAuthAppDeleted as publicOnOAuthAppDeleted } from './headless-v1-o-auth-app-o-auth-apps.public.js';
import { onOAuthAppUpdated as publicOnOAuthAppUpdated } from './headless-v1-o-auth-app-o-auth-apps.public.js';
export declare const createOAuthApp: MaybeContext<BuildRESTFunction<typeof publicCreateOAuthApp> & typeof publicCreateOAuthApp>;
export declare const getOAuthApp: MaybeContext<BuildRESTFunction<typeof publicGetOAuthApp> & typeof publicGetOAuthApp>;
export declare const updateOAuthApp: MaybeContext<BuildRESTFunction<typeof publicUpdateOAuthApp> & typeof publicUpdateOAuthApp>;
export declare const queryOAuthApps: MaybeContext<BuildRESTFunction<typeof publicQueryOAuthApps> & typeof publicQueryOAuthApps>;
/**
 * Triggered when an OAuth app is created.
 */
export declare const onOAuthAppCreated: ReturnType<typeof createEventModule<typeof publicOnOAuthAppCreated>>;
/**
 * Triggered when an OAuth app is deleted.
 */
export declare const onOAuthAppDeleted: ReturnType<typeof createEventModule<typeof publicOnOAuthAppDeleted>>;
/**
 * Triggered when an OAuth app is updated.
 */
export declare const onOAuthAppUpdated: ReturnType<typeof createEventModule<typeof publicOnOAuthAppUpdated>>;
export { OAuthAppType, OAuthTechnologies, SortOrder, State, SiteCreatedContext, Namespace, DeleteStatus, WebhookIdentityType, } from './headless-v1-o-auth-app-o-auth-apps.universal.js';
export { OAuthApp, CreateOAuthAppRequest, CreateOAuthAppResponse, GetOAuthAppRequest, GetOAuthAppResponse, UpdateOAuthAppRequest, UpdateOAuthAppResponse, DeleteOAuthAppRequest, DeleteOAuthAppResponse, QueryOAuthAppsRequest, PlatformQuery, PlatformQueryPagingMethodOneOf, Sorting, Paging, CursorPaging, QueryOAuthAppsResponse, PagingMetadataV2, Cursors, GenerateOAuthAppSecretRequest, GenerateOAuthAppSecretResponse, MetaSiteSpecialEvent, MetaSiteSpecialEventPayloadOneOf, Asset, SiteCreated, SiteTransferred, SiteDeleted, DeleteContext, SiteUndeleted, SitePublished, SiteUnpublished, SiteMarkedAsTemplate, SiteMarkedAsWixSite, ServiceProvisioned, ServiceRemoved, SiteRenamed, SiteHardDeleted, NamespaceChanged, StudioAssigned, StudioUnassigned, SiteUrlChanged, SitePurgedExternally, OdeditorAssigned, OdeditorUnassigned, PicassoAssigned, PicassoUnassigned, Empty, DomainEvent, DomainEventBodyOneOf, EntityCreatedEvent, RestoreInfo, EntityUpdatedEvent, EntityDeletedEvent, ActionEvent, MessageEnvelope, IdentificationData, IdentificationDataIdOneOf, BaseEventMetadata, EventMetadata, OAuthAppCreatedEnvelope, OAuthAppDeletedEnvelope, OAuthAppUpdatedEnvelope, UpdateOAuthApp, OAuthAppsQueryResult, OAuthAppsQueryBuilder, } from './headless-v1-o-auth-app-o-auth-apps.universal.js';
