"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebhookIdentityType = exports.State = exports.SortOrder = exports.SiteCreatedContext = exports.OAuthTechnologies = exports.OAuthAppType = exports.Namespace = exports.DeleteStatus = exports.onOAuthAppUpdated = exports.onOAuthAppDeleted = exports.onOAuthAppCreated = exports.generateOAuthAppSecret = exports.queryOAuthApps = exports.deleteOAuthApp = exports.updateOAuthApp = exports.getOAuthApp = exports.createOAuthApp = exports.__metadata = void 0;
const rename_all_nested_keys_1 = require("@wix/sdk-runtime/rename-all-nested-keys");
const timestamp_1 = require("@wix/sdk-runtime/transformations/timestamp");
const transform_paths_1 = require("@wix/sdk-runtime/transformations/transform-paths");
const sdk_types_1 = require("@wix/sdk-types");
const headless_v1_o_auth_app_o_auth_apps_universal_js_1 = require("./headless-v1-o-auth-app-o-auth-apps.universal.js");
exports.__metadata = { PACKAGE_NAME: '@wix/auth-management' };
function createOAuthApp(httpClient) {
    return (oAuthApp) => (0, headless_v1_o_auth_app_o_auth_apps_universal_js_1.createOAuthApp)(oAuthApp, 
    // @ts-ignore
    { httpClient });
}
exports.createOAuthApp = createOAuthApp;
function getOAuthApp(httpClient) {
    return (oAuthAppId) => (0, headless_v1_o_auth_app_o_auth_apps_universal_js_1.getOAuthApp)(oAuthAppId, 
    // @ts-ignore
    { httpClient });
}
exports.getOAuthApp = getOAuthApp;
function updateOAuthApp(httpClient) {
    return (_id, oAuthApp, mask) => (0, headless_v1_o_auth_app_o_auth_apps_universal_js_1.updateOAuthApp)(_id, oAuthApp, mask, 
    // @ts-ignore
    { httpClient });
}
exports.updateOAuthApp = updateOAuthApp;
/** @internal */
function deleteOAuthApp(httpClient) {
    return (oAuthAppId) => (0, headless_v1_o_auth_app_o_auth_apps_universal_js_1.deleteOAuthApp)(oAuthAppId, 
    // @ts-ignore
    { httpClient });
}
exports.deleteOAuthApp = deleteOAuthApp;
function queryOAuthApps(httpClient) {
    return () => (0, headless_v1_o_auth_app_o_auth_apps_universal_js_1.queryOAuthApps)(
    // @ts-ignore
    { httpClient });
}
exports.queryOAuthApps = queryOAuthApps;
/** @internal */
function generateOAuthAppSecret(httpClient) {
    return (oAuthAppId) => (0, headless_v1_o_auth_app_o_auth_apps_universal_js_1.generateOAuthAppSecret)(oAuthAppId, 
    // @ts-ignore
    { httpClient });
}
exports.generateOAuthAppSecret = generateOAuthAppSecret;
exports.onOAuthAppCreated = (0, sdk_types_1.EventDefinition)('wix.headless.v1.o_auth_app_created', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'entity.createdDate' },
            { path: 'metadata.eventTime' },
        ],
    },
])))();
exports.onOAuthAppDeleted = (0, sdk_types_1.EventDefinition)('wix.headless.v1.o_auth_app_deleted', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'undefined.createdDate' },
            { path: 'metadata.eventTime' },
        ],
    },
])))();
exports.onOAuthAppUpdated = (0, sdk_types_1.EventDefinition)('wix.headless.v1.o_auth_app_updated', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'entity.createdDate' },
            { path: 'metadata.eventTime' },
        ],
    },
])))();
var headless_v1_o_auth_app_o_auth_apps_universal_js_2 = require("./headless-v1-o-auth-app-o-auth-apps.universal.js");
Object.defineProperty(exports, "DeleteStatus", { enumerable: true, get: function () { return headless_v1_o_auth_app_o_auth_apps_universal_js_2.DeleteStatus; } });
Object.defineProperty(exports, "Namespace", { enumerable: true, get: function () { return headless_v1_o_auth_app_o_auth_apps_universal_js_2.Namespace; } });
Object.defineProperty(exports, "OAuthAppType", { enumerable: true, get: function () { return headless_v1_o_auth_app_o_auth_apps_universal_js_2.OAuthAppType; } });
Object.defineProperty(exports, "OAuthTechnologies", { enumerable: true, get: function () { return headless_v1_o_auth_app_o_auth_apps_universal_js_2.OAuthTechnologies; } });
Object.defineProperty(exports, "SiteCreatedContext", { enumerable: true, get: function () { return headless_v1_o_auth_app_o_auth_apps_universal_js_2.SiteCreatedContext; } });
Object.defineProperty(exports, "SortOrder", { enumerable: true, get: function () { return headless_v1_o_auth_app_o_auth_apps_universal_js_2.SortOrder; } });
Object.defineProperty(exports, "State", { enumerable: true, get: function () { return headless_v1_o_auth_app_o_auth_apps_universal_js_2.State; } });
Object.defineProperty(exports, "WebhookIdentityType", { enumerable: true, get: function () { return headless_v1_o_auth_app_o_auth_apps_universal_js_2.WebhookIdentityType; } });
//# sourceMappingURL=headless-v1-o-auth-app-o-auth-apps.public.js.map