import * as ambassadorWixHeadlessV1OAuthApp from './headless-v1-o-auth-app-o-auth-apps.http.js';
export function createOAuthApp() {
    const payload = {};
    const getRequestOptions = ambassadorWixHeadlessV1OAuthApp.createOAuthApp(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v1/oauth-apps',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function getOAuthApp() {
    const payload = { oAuthAppId: ':oAuthAppId' };
    const getRequestOptions = ambassadorWixHeadlessV1OAuthApp.getOAuthApp(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'GET',
        path: '/v1/oauth-apps/{oAuthAppId}',
        pathParams: { oAuthAppId: 'oAuthAppId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function updateOAuthApp() {
    const payload = { oAuthApp: { id: ':oAuthAppId' } };
    const getRequestOptions = ambassadorWixHeadlessV1OAuthApp.updateOAuthApp(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'PATCH',
        path: '/v1/oauth-apps/{oAuthApp.id}',
        pathParams: { oAuthAppId: 'oAuthAppId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function deleteOAuthApp() {
    const payload = { oAuthAppId: ':oAuthAppId' };
    const getRequestOptions = ambassadorWixHeadlessV1OAuthApp.deleteOAuthApp(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'DELETE',
        path: '/v1/oauth-apps/{oAuthAppId}',
        pathParams: { oAuthAppId: 'oAuthAppId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function queryOAuthApps() {
    const payload = {};
    const getRequestOptions = ambassadorWixHeadlessV1OAuthApp.queryOAuthApps(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v1/oauth-apps/query',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function generateOAuthAppSecret() {
    const payload = { oAuthAppId: ':oAuthAppId' };
    const getRequestOptions = ambassadorWixHeadlessV1OAuthApp.generateOAuthAppSecret(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v1/oauth-apps/{oAuthAppId}/generate-secret',
        pathParams: { oAuthAppId: 'oAuthAppId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
//# sourceMappingURL=headless-v1-o-auth-app-o-auth-apps.meta.js.map